Subject: bug#12911: 24.3.50; let users decide where (& perhaps whether) `emacs_backtrace.txt' files are written

From: "Drew Adams" <[email-masked]>
Date: Sun, 18 Nov 2012 10:42:03 -0800

> > I don't care what Emacs does on Unix or on Windows.
> 
> Well, I do.  Which is why I'm working on developing and maintaining
> Emacs.  

Read my statement in context.  Taking it out of context reverses the intended
meaning.

> And if you think that declaring your indifference to the
> cross-platform compatibility of Emacs

I did no such thing.  I am not at all indifferent to cross-platform
compatibility.  As you know full well.

> raises the value of your arguments in my eyes, then I
> suggest that you reconsider.
> 
> > my concern is at the user level.  Please don't mess with 
> > user data.  That's not nice.  And this includes user folders
> > containing user files.
> 
> Any folder on Windows can contain user data, because most Windows
> users are usually local administrators and have almost unlimited
> privileges (except perhaps on corporate servers).

Don't make the perfect the enemy of the good.  You are stretching things.

Yes, what you say is true.  No, it is not particularly relevant.  Yes, my entire
C:/ drive is my drive and my data.  So what?  Irrelevant to the discussion.
Please stick to the particulars.

> In fact, Windows
> doesn't even have a firm notion of a home directory.  There are
> guidelines where _applications_ should put their files, but nothing
> about what is "home" for the user, where the user should keep her
> precious lasagna recipes.  We (Emacs) pick up one or 2 plausible
> locations and pretend they are that "home", but they aren't, as far as
> the OS and the rest of applications are concerned.  They are just more
> or less random directories.

I have no argument with any of what you said there.

> > The first rule should be not to do any harm.
> 
> You are making a mount out of a molehill.  There is no harm.
> Well-behaving applications write to all kinds of directories all the
> time, including user home directories.  Bash writes ~/.bash_history,
> Bazaar writes ~/.bzr.log, Eshell writes ~/.eshell/*.  Etc. etc. --
> this is the norm, not the exception.  Emacs behaves according to
> well-established norms.
> 
> I agree that putting that file in ~/.emacs.d/ (also in the home a
> directory, so maybe you will still protest) is slightly better.

Why would I protest?  I'm the one who _suggested_ putting it there.

And I have not once mentioned "home" directory in this discussion.  Perhaps you
are confusing me with someone else.

Anyway, I'm very glad you agree about ~/.emacs.d/.  So at the very least this
bug should remain open on the wishlist until fixed.

To me, this bother is a regression, as I said earlier.  But whether you look at
it like that or not, at least you agree that it is better to put the file in
~/.emacs.d/.  That's progress.

> But if Emacs should do that, it should do it on all the
> supported platforms.  I'm sorry, but unless this is what's
> agreed soon, I _will_ close this bug.

I have no problem with the bug being fixed on all platforms.  In fact, I have
explicitly said (several times now) that if this is also a problem on other
platforms then it _should_ be fixed there as well.

And in the very mail which you quoted out of context above, reversing the sense
of what I wrote!  This is what I said:

 If Emacs on Unix is just as user-inconsiderate in this
 regard as it is on Windows, then it too needs to be sent
 back for regrooving.

And:

 On any platform.  It does not belong there.  I just happen
 to be using Emacs on Windows, and I reported this problem
 there.  If it is not Windows-specific, fine - please fix it
 wherever it occurs.

Pretty damn clear, no?  And this:

 If there is a problem on platform XYZ, please fix it on XYZ.
 For all XYZ, preferably.  For Windows, at least.

Is this problem a mountain or a mole hill?  Closer to the latter, clearly.  But
Emacs users never had this bother before.  Why should they have it now?

Just because on MS Windows everything belongs to the user is no excuse to start
polluting arbitrary folders.  Such an argument is way off-base.

A family who does not (or even cannot) lock their front door is not _asking_ you
to come in and trash their house.